<?
/**
 * Автор скрипта Орёл
 * Распространение бесплатно
 * icq: 952042
 * E-mail xvab@bk.ru
 */

# Path относительно корня
defined('ROOT') or define('ROOT', str_replace('\\', '/', realpath(dirname (__FILE__))) .'/');
define('IN_ACCESS', 1);

include ('includes/config.php');
include ('includes/ini_set.php');
include ('includes/functions.php');
include ('includes/db.php');
include ('includes/const.php');

# Старт сессии
session_name('SID');
session_start();

# php роутинг
f_import('lib/route.php');
$route = New Route();

# Класс хранения методов
f_import('lib/registry.php');

# Подключения хелпера, главного модуля
f_import('modules/main/helpers/main_helper.php');
$main = LoadClass('Main');

# Добавляем данные в Registry
Registry :: set('config', $config);

f_import('lib/file_cache');
Registry :: set('cache', New File_Cache(ROOT .'local/cache'));

# Подключение контроллера
f_import('lib/controller.php');

# Ежедневные события в системе
f_import('includes/eventday.php');

# Загрузка шаблонизатора
f_import('lib/template.php');
$tpl = New pattern;
Registry :: set('tpl', $tpl);

# Загрузка модуля
include_once ROUTE_MODULE_PATH;

# Загрузка класса
$controller = a_load_class(ROUTE_MODULE_PATH, 'controller');

if (!empty($route->action)) {
        $action_method = 'action_' . $route->action;
        if (method_exists($controller, $action_method)) {
                $controller->$action_method();
        } else {
                redirect(p_url('main/page_notfound'));
        }
} else {
        if (method_exists($controller, 'action_index')) {
                $controller->action_index();
        } else {
                redirect(p_url('main/page_notfound'));
        }
}
?>