<?
abstract class Controller {
        /**
         *  Текущая страница
         */
        protected $start = 0;
        /**
         * Количетсво элементов на страницу
         */
        protected $page_rows = 10;
        /**
         * Массив настроек
         */
        protected $config;
        /**
         * Метод шаблонизатора
         */
        protected $tpl;
        /**
         * Определение админа
         * @var <type>
         */
        protected $admin;
        /**
         * Кэширование
         * @var <type>
         */
        protected $cache;

        function __construct() {
                # Запуск таймера
                define('STARTTIME', microtime(1));
                # Определение админа
                if ($_SESSION['admin']) {
                        $this->admin = 1;
                        define('IS_ADMIN', 1);
                } else {
                        define('IS_ADMIN', 0);
                }
                # Расчёт страницы
                # для постраничной навигации
                $this->start = !empty($_GET['start']) ? intval($_GET['start']) : 0;
                $this->start = is_numeric($_GET['page']) ? $_GET['page'] * $this->page_rows - 1 : $this->start;

                # Получение методов
                $this->config = Registry :: get('config');
                $this->tpl = Registry :: get('tpl');
                $this->cache = Registry :: get('cache');

                # Определение системы пользователя
                if (!isset($_SESSION['user_typesoft'])){
                        $_SESSION['user_typesoft'] = (int)Main :: UserSoft();
                }
        }

}

?>